﻿// ================================================================
var SCRIPT_FILE = new File( $.fileName );

var script = {
	name: 'findChangeSets',
	version: 1.0,
	versionStr: function(){
		return this.version%1 ? this.version.toString() : this.version+'.0';
		},
	insertLabel: function( string ){
		app.insertLabel( this.name, string );
		},
	extractLabel: function(){
		return app.extractLabel( this.name );
		},
	};

// ============ INI =======================

if( !app.documents.length ){
	alert( 'Open document and try again' );
	exit();
	}
var DOC = app.documents[0];

var PROCESSED_XML;

// ============ OPTIONS ==================

var LAST_PRESET_NAME = '';
var SHOW_REPORT = false;

function saveOptions(){
	var str = "LAST_PRESET_NAME = '"+LAST_PRESET_NAME+"';\
	SHOW_REPORT = "+SHOW_REPORT+";";
	script.insertLabel( str );
	}

// ini options
eval( script.extractLabel() ); 

// ============ PRESETS ==================

var PRESETS_FOLDER = new Folder( SCRIPT_FILE.parent.absoluteURI + '/' + script.name );
XML.prettyPrinting = true; // Включаем табуляцию и абзацы у строкового представления xml

function getPresetFilesBasa(){
	PRESETS_FOLDER.create();
	var PRESET_FILES = PRESETS_FOLDER.getFiles( '*.xml' );
	var basa = {};
	for( var i = 0; i < PRESET_FILES.length; i++ )
		basa[getFileNameOnly(PRESET_FILES[i])] = PRESET_FILES[i];
	return basa;
	}

function getDefaultXmlPreset(){
	return <{script.name} version={script.versionStr()}>
<!--		<query enable="true" method="Grep" findWhat="" changeTo=""/> -->
	</{script.name}>;
	}

//========= ЛОКАЛИЗАЦИЯ ================================================
var lang = ( $.locale == 'ru_RU' ) ? 'ru' : 'en';
var messages = {
	en: {
		searchArea: 'Search area: ',
		document: 'Document',
		selectedStory: 'Selected story',
		selectedText: 'Selected text',
		selectedTable: 'Selected table',
		selectedCells: 'Selected cells',
		selectedRows: 'Selected rows',
		selectedColumns: 'Selected columns',
		
		noOpenDocs: 'No open documents',
		processFullDoc: 'Document will be processed completely.\r\rContinue?',
		showReport: 'Show report',
		showReportHelpTip: '',
		preset: 'Preset',
		findChange: 'Find/Change',
		},
	ru: {
		searchArea: 'Зона поиска: ',
		document: 'Документ',
		selectedStory: 'Выдел. материал',
		selectedText: 'Выдел. текст',
		selectedTable: 'Выдел. таблица',
		selectedCells: 'Выдел. ячейки',
		selectedRows: 'Выдел. строки',
		selectedColumns: 'Выдел. столбцы',
		
		noOpenDocs: 'Нет открытых документов',
		processFullDoc: 'Будет обработано содержание всего документа.\r\rПродолжить?',
		showReport: 'Показать отчет',
		showReportHelpTip: 'Показать отчет после отработки набора',
		preset: 'Пресет',
		findChange: 'Найти/Заменить',
		}
	};
function getLocale(flag){
	return messages[lang][flag] || flag;
	}

//=====================================================================
//=====================================================================

//======== ПРОВЕРЯЕМ ЧТО У НАС ВЫДЕЛЕНО ================================
// Определяем область обработки (взято из findChangeQueryList2)
var AREA; // object
var searchArea = ''; // title
if(app.selection[0] == undefined){
	if( !confirm( getLocale('processFullDoc'), true, script.name ) )
		exit();
	AREA = app.activeDocument;
	searchArea = getLocale('searchArea') + getLocale('document');
	}
else
	switch(app.selection[0].constructor.name){
		case 'TextFrame':
		case 'InsertionPoint':
		AREA = app.selection[0].parentStory; // Цепочка фреймов
		searchArea = getLocale('searchArea') + getLocale('selectedStory');
		break;
		case 'Text':
		case 'TextColumn':
		case 'Paragraph':
		case 'Table':
		case 'Cell':
		case 'Row':
		case 'Column':
		AREA = app.selection[0];
		
		switch(app.selection[0].constructor.name){
			case 'Text':
			case 'TextColumn':
			case 'Paragraph':
			searchArea = getLocale('searchArea') + getLocale('selectedText');
			break;
			case 'Table':
			searchArea = getLocale('searchArea') + getLocale('selectedTable');
			break;
			case 'Cell':
			searchArea = getLocale('searchArea') + getLocale('selectedCells');
			break;
			case 'Row':
			searchArea = getLocale('searchArea') + mgetLocale('selectedRows');
			break;
			case 'Column':
			searchArea = getLocale('searchArea') + getLocale('selectedColumns');
			break;
			}
		
		break;
		default:
		if( !confirm( 'Current selection: ' +app.selection[0].constructor.name+'.\r\r' + getLocale('processFullDoc'), true, script.name ) )
			exit();
		AREA = app.activeDocument;
		searchArea = getLocale('searchArea') + getLocale('document');
		}

if( getDialog() && PROCESSED_XML ){
	
	var queries = PROCESSED_XML.xpath( "query[@enable = 'true' and @findWhat != '']" );
	var report = [];
	var res;
	if( queries.length() ){
		for( var i = 0; i < queries.length(); i++ ){
			res = doFindChange( {type: queries[i].@method.toString(), findWhat: queries[i].@findWhat.toString(), changeTo: queries[i].@changeTo.toString(), area: AREA, findPreferences: false, changePreferences: false, topLevelOnly: true} );
			report.push( res.length + ': "' + queries[i].@findWhat.toString() + '" > "' + queries[i].@changeTo.toString() + '"' );
			}
		}
	if( SHOW_REPORT && report.length )
		alert( report.join('\r'), 'Result' );
	}

saveOptions();

// ============ DIALOG ================================================
function getDialog( pageRange ){
	var win = new Window( "dialog", script.name + ' v.' + script.versionStr() + ' ['+searchArea+']', undefined );
	win.alignChildren = ['left', 'top'];
	win.margins = 5;
	win.spacing = 5;
	with(win){
		win.line = add( "panel", undefined, undefined );
		win.line.preferredSize.height = 2;
		win.line.alignment = ['fill', 'top'];
		win.presets = add( "group", undefined, undefined );
		win.presets.spacing = 5;
		with(win.presets){
			add( "statictext", undefined,  getLocale('preset') ).indent = 5;
			win.presets.ddList = add( "dropdownlist", undefined, undefined, {items: ['...','-'], } );
			win.presets.ddList.preferredSize.width = 200;
			//win.presets.ddList.title = getLocale('preset');
			win.presets.save = add( "button", undefined, 'Save' );
			win.presets.saveAs = add( "button", undefined, 'Save As' );
			win.presets.delete = add( "button", undefined, 'Delete' );
			}
		win.line = add( "panel", undefined, undefined );
		win.line.preferredSize.height = 2;
		win.line.alignment = ['fill', 'top'];
		
		win.findChange = add( "panel", undefined, getLocale('findChange') );
		win.findChange.enabled = false;
		
		win.buts = add( "group", undefined, undefined );
		win.buts.alignment = ['fill', 'top'];
		with(win.buts){
			win.showReport = add( "checkbox", undefined, getLocale('showReport') );
			win.showReport.helpTip = getLocale('showReportHelpTip');
			win.showReport.alignment = ['left', 'center'];
			
			win.buts.cancel = add( "button", undefined, 'Cancel' );
			win.buts.cancel.alignment = ['right', 'top'];
			win.buts.OK = add( "button", undefined, 'OK' );
			win.buts.OK.alignment = ['right', 'top'];
			}
		}
	
	// НАЙТИ / ЗАМЕНИТЬ
	getUIQueriesList( win.findChange, 
		[{
			type: "checkbox", // edittext | checkbox | radiobutton | dropdownlist,
			key: "enable",
			title: "Active",
			width: 70, // number,
			default_value: "true",
			values: ["","",""], // array of strings // Only for radiobutton | dropdownlist
		},{
			type: "radiobutton", // edittext | checkbox | radiobutton | dropdownlist,
			key: "method",
			title: "Method",
			width: 70, // number,
			default_value: "Text",
			values: ["Text","Grep"], // array of strings // Only for radiobutton | dropdownlist
		},{
			type: "edittext", // edittext | checkbox | radiobutton | dropdownlist,
			key: "findWhat",
			title: "Find",
			width: 300, // number,
			default_value: "",
			values: ["","",""], // array of strings // Only for radiobutton | dropdownlist
		},{
			type: "edittext", // edittext | checkbox | radiobutton | dropdownlist,
			key: "changeTo",
			title: "Change",
			width: 300, // number,
			default_value: "",
			values: ["","",""], // array of strings // Only for radiobutton | dropdownlist
		}]
		);
	
	// PRESETS
	win.presets.ddList.onChange = function(){
		try{
		if( this.SLEEP )
			return;
		
		if( win.presets.ddList.children.length == 2 )
			win.findChange.enabled = false;
			
		if( !this.selection ){
			win.findChange.enabled = false;
			return;
			}
		
		// сохраняем текущий
		if( this.lastPresetName ){
			var listItem = win.presets.ddList.find( this.lastPresetName );
			if( listItem && listItem.savedXmlStr != win.findChange.XML.toXMLString() ){
				var res = confirmWithCancel( "Save preset '" + listItem.text + "'?" ); // defaultButton = ok|no|cancel, return true|false|null
				if( res === null ){
					this.SLEEP = true;
					this.selection = listItem;
					this.SLEEP = false;
					return;
					}
				else if( res ){
					write_xml_file( listItem.presetFile, win.findChange.XML );
					listItem.savedXmlStr = win.findChange.XML.toXMLString();
					}
				}
			}
		
		// New preset
		if( this.selection.text == '...' ){ 
			var newName = prompt( 'New preset: ', '', script.name );
			var flag = true;
			if( !newName )
				flag = false;
			else if( newName == '...' ){
				alert( 'Incorrect name: ...' );
				flag = false;
				}
			else{
				newName = adaptForFileName( newName );
				if( this.find(newName) ){
					alert( 'Preset already exists: ' + newName );
					flag = false;
					}
				}
			if( !flag ){
				if( this.lastPresetName && this.find(this.lastPresetName) ){
					this.SLEEP = true;
					this.selection = this.find(this.lastPresetName);
					this.SLEEP = false;
					}
				else
					this.selection = null;
				return;
				}
			
			// load new xml
			win.findChange.loadXml( getDefaultXmlPreset() );
			win.findChange.enabled = true;
			// create xml file
			var xml_file = new File( PRESETS_FOLDER.absoluteURI + '/'+ newName + '.xml' );
			write_xml_file(xml_file, win.findChange.XML);
			// add listItem
			var listItem = win.presets.ddList.add( 'item', newName );
			listItem.presetFile = xml_file;
			listItem.savedXmlStr = win.findChange.XML.toXMLString();
			// select listItem
			this.SLEEP = true;
			win.presets.ddList.selection = win.presets.ddList.find( newName );
			this.SLEEP = false;
			// запоминаем текущий пресет
			this.lastPresetName = newName;
			}
		// Load selected preset
		else{
			// load new xml
			win.findChange.loadXml( read_xml_file(this.selection.presetFile) );
			this.selection.savedXmlStr = win.findChange.XML.toXMLString();
			win.findChange.enabled = true;
			// запоминаем текущий пресет
			this.lastPresetName = this.selection.text; 
			}
		}catch(err){ alertError( err ) }
		}
	win.presets.save.onClick = function(){
		if( !win.presets.ddList.selection )
			return;
		var listItem = win.presets.ddList.selection;
		if( listItem.savedXmlStr != win.findChange.XML.toXMLString() ){
			write_xml_file( listItem.presetFile, win.findChange.XML );
			listItem.savedXmlStr = win.findChange.XML.toXMLString();
			}
		}
	win.presets.saveAs.onClick = function(){
		if( !win.presets.ddList.selection )
			return;
		var newName = prompt( 'Save as: ', '', script.name );
		if( !newName )
			return;
		newName = adaptForFileName( newName );
		if( newName == '...' ){
			alert( 'Incorrect name: ...' );
			return;
			}
		if( win.presets.ddList.find(newName) ){
			alert( 'Preset already exists: ' + newName );
			return;
			}
		
		// create xml file
		var xml_file = new File( PRESETS_FOLDER.absoluteURI + '/'+ newName + '.xml' );
		write_xml_file(xml_file, win.findChange.XML);
		// add listItem
		var listItem = win.presets.ddList.add( 'item', newName );
		listItem.presetFile = xml_file;
		listItem.savedXmlStr = win.findChange.XML.toXMLString();
		// select listItem
		win.presets.ddList.SLEEP = true;
		win.presets.ddList.selection = win.presets.ddList.find( newName );
		win.presets.ddList.SLEEP = false;
		// запоминаем текущий пресет
		win.presets.ddList.lastPresetName = newName; 
		}
	win.presets.delete.onClick = function(){
		if( !win.presets.ddList.selection )
			return;
		var itemList = win.presets.ddList.selection;
		if( !confirm("Delete '" + itemList.text +"'?") )
			return;
		itemList.presetFile.remove();
		win.presets.ddList.remove( itemList );
		win.findChange.loadXml( getDefaultXmlPreset() );
		
		win.presets.ddList.lastPresetName = '';
		win.presets.ddList.selection = null;
		}
	
	// showReport
	win.showReport.onClick = function(){
		SHOW_REPORT = this.value;
		}
	win.showReport.value = SHOW_REPORT;
	
	// OK
	var STATUS = false;
	win.buts.cancel.onClick = function(){
		this.window.close();
		}
	win.buts.OK.onClick = function(){
		STATUS = true;
		this.window.close();
		}
	
	// INI PRESET
	var basa = getPresetFilesBasa();
	var listItem;
	for( var presetName in basa ){
		win.presets.ddList.add( 'item', presetName ).presetFile = basa[presetName];
		}
	if( LAST_PRESET_NAME )
		win.presets.ddList.selection = win.presets.ddList.find( LAST_PRESET_NAME );
//	win.presets.ddList.onChange();

	win.onClose = function(){
		LAST_PRESET_NAME = win.presets.ddList.lastPresetName;
		
		var listItem = win.presets.ddList.selection;
		if( !listItem )
			return; // выходим
		
		PROCESSED_XML = win.findChange.XML;
		//сохранение текущего набора
		if( listItem.savedXmlStr != win.findChange.XML.toXMLString() ){
			var res = confirmWithCancel( "Save preset '" + listItem.text + "'?" ); // defaultButton = ok|no|cancel, return true|false|null
			if( res === null )
				return false; //прервать выход 
			else if( res )
				write_xml_file( listItem.presetFile, win.findChange.XML );
			}
		}
	win.defaultElement = win.buts.OK;
	win.center();
	win.show();
	
	return STATUS;
	}

//=====================================================================
//=====================================================================
function alertError( err, sourceOfError ){
	if( !err )
		return;
	var errMessage = err.constructor == Error ? err + '; line: ' + err.line : err;
	errMessage = (sourceOfError? sourceOfError + ': ' : '') + errMessage;
	alert( errMessage );
	}
//=====================================================================
function getFileNameOnly( file ){ // Внимание: для получения имени папки не использовать
	if( file instanceof Folder )
		return getFileName( file );
	return getFileName( file ).split('.').slice(0,-1).join('.');
	// вариант 2
	return file.fsName.substring( file.parent.fsName.length+1, file.fsName.lastIndexOf('.') )
	}
function getFileName( file ){
	return file.fsName.split(/[\\\/]/).reverse()[0];
	// вариант 2
	return file.fsName.substring( file.parent.fsName.length+1 );
	}
function getFileExtention( file ){
	if( file instanceof Folder )
		return '';
	return file.fsName.substring( file.fsName.lastIndexOf('.')+1 );
	}
function writeFile( FILE, string, writeMode ){ // return true || false || Error
	if( !FILE )
		return false;
	writeMode = writeMode ? writeMode : 'w';
	try{
	FILE.open( writeMode );
	FILE.encoding = "UTF-8";
	var strings = string.split( /[\r\n]/ );
	for( var i = 0; i < strings.length; i++ )
		FILE.writeln( strings[i] );
//	FILE.write( string );
	FILE.close();
	if( !FILE.exists )
		return false;
	return true;
	}catch(err){
		alertError( err );
		return false;
		}
	}
function write_xml_file( toFile, xml, header ){
	var str = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\r" + (header ? header+"\r" : "") + xml.toXMLString();
	return writeFile( toFile, str );
	}
function read_xml_file( XMLFile, returnError ){ // return XML or false or Error (if returnError = true)
	try{
	if( !XMLFile.exists )
		throw new Error( 'XML file not found: ' + XMLFile.fsName );
	XMLFile.open('r');
	var res = XMLFile.read();
	XMLFile.close();
	if( !res )
		throw new Error( 'Error read XML file: ' + XMLFile.fsName );
	var myXML = new XML( res );
	if( !myXML )
		throw new Error( 'Error load XML from file: ' + XMLFile.fsName );
	return myXML;
	}catch(err){
		if( returnError )
			return err;
		alertError( err );
		return false;
		}
	}

function adaptForFileName( str ){
	return str.toString().replace(/[\r\n\t\\\/:*?"<>|]+/g, '_');
	}
//=====================================================================

function confirmWithCancel( text, defaultButton ){ // defaultButton = ok|no|cancel, return true|false|null
	// v.1
	var res;
	var _win = new Window( 'dialog' );
	_win.add( 'statictext', undefined, text );
	_win.buts = _win.add( 'group' );
	_win.buts.orientation = 'row';
	_win.buts.ok = _win.buts.add( 'button', undefined, 'Ok', {flag: 'ok'} );
	_win.buts.no = _win.buts.add( 'button', undefined, 'No', {flag: 'no'} );
	_win.buts.cancel = _win.buts.add( 'button', undefined, 'Cancel', {flag: 'cancel'} );
	_win.buts.ok.onClick = _win.buts.no.onClick = _win.buts.cancel.onClick = function(){
		switch( this.properties.flag ){
			case 'ok':
				res = true;
				break;
			case 'no':
				res = false;
				break;
			case 'cancel':
				res = null;
				break;
			}
		_win.close();
		}
	switch( defaultButton ){
		case 'ok':
			_win.defaultElement = _win.buts.ok;
			break;
		case 'no':
			_win.defaultElement = _win.buts.no;
			break;
		case 'cancel':
			_win.defaultElement = _win.buts.cancel;
			break;
		default:
			_win.defaultElement = _win.buts.ok;
		}
	
	_win.center();
	_win.show();
	
	return res;
	}

//=====================================================================
function doFindChange( opts ){ // return Array
	// v.1.3
	// Quick code
	// doFindChange( {type: 'Grep', findWhat: 'zzz', changeTo: 'ddd', area: app.selection[0], findPreferences: false, changePreferences: {fontStyle: "Bold"}, topLevelOnly: false, getFirstFindResultOnly: false} );
	try{
	// opts = {
	//	type: 'Text' or 'Grep'
	//	findWhat: String
	//	changeTo: String. Optional. ВНИМАНИЕ: пустая строка означает замену найденных элементов на пустую строку
	//	area: Object, поддерживающий метод findText или findGrep, или Array of Objects (напр., app.selection)
	//	findPreferences: findTextPreferences or findGrepPreferences. Optional
	//	changePreferences: changeTextPreferences or changeGrepPreferences. Optional
	//	
	//	topLevelOnly: Bool. Optional (default: false). Если true - вложеные page items орабатываться не будут 
	//	getFirstFindResultOnly: Bool.Optional (default: false). 
	//	}
	// INI
	if( !opts )
		return [];
	if( !opts.type || !/^(Text|Grep)$/.test(opts.type) )
		throw new Error( "opts.type = " + opts.type );
	var res = [];
	var area = arguments.length > 1 ? arguments[1] : opts.area;
	if( !area )
		throw new Error( "area = " + area );
	
	if( area instanceof Array ){ // array|app.selection|allPageItems
		var this_res;
		for( var i = 0; i < area.length; i++ ){
			this_res = arguments.callee( opts, area[i] );
			if( this_res.length ){
				if( opts.getFirstFindResultOnly ){
					return [this_res[0]];
					}
				res = res.concat( this_res );
				}
			}
		return res;
		}
	
	if( area.hasOwnProperty("find"+opts.type) ){
		$.writeln ('opts.findPrefsInitialized: ' + opts.findPrefsInitialized)
		// EXE
		if( !opts.findPrefsInitialized ){ // подгружаем настройки find/change один раз
			var findPrefsStr = 'find' + opts.type + 'Preferences';
			var changePrefsStr = 'change' + opts.type + 'Preferences';
			app[findPrefsStr] = app[changePrefsStr] = null;
			
			var appFindPreferences = app[findPrefsStr];
			appFindPreferences.findWhat = ( opts.findWhat && opts.findWhat.constructor == String ) ? opts.findWhat : NothingEnum.NOTHING;
			if( opts.findPreferences )
				for( var i in opts.findPreferences )
					appFindPreferences[i] = opts.findPreferences[i];
			
			opts.findPrefsInitialized = true;
			
			if( opts.changeTo && opts.changeTo.constructor == String || opts.changePreferences ){
				var appChangePreferences  = app[changePrefsStr];
				appChangePreferences.changeTo = ( opts.changeTo && opts.changeTo.constructor == String ) ? opts.changeTo : NothingEnum.NOTHING;
				var flag = false;
				if( opts.changePreferences )
					for( var i in opts.changePreferences ){
						flag = true;
						appChangePreferences[i] = opts.changePreferences[i];
						}
				if( appChangePreferences.changeTo != NothingEnum.NOTHING || flag )
					opts.changePrefsInitialized = true;
				}
			}
		
		res = area["find"+opts.type]();
		if( res == null )
			return [];
		else if( opts.changePrefsInitialized ){
			try{ area["change"+opts.type](); }catch(err){}
			}
		
		if( opts.getFirstFindResultOnly ){
			return res.length ? [res[0]] : res;
			}
		}
	
	//app[findPrefsStr] = app[changePrefsStr] = null;
	
	// обрабатываем все вложеные page items
	if( !opts.topLevelOnly && area.hasOwnProperty("allPageItems") && area.allPageItems.length ){
		res = res.concat( arguments.callee(opts, area.allPageItems) );
		}
	
	}catch(err){
		alertError( err, 'doFindChange('+(opts.type ? 'type='+opts.type : '')+'). area.constructor.name = ' + area.constructor.name );
		 }
	 
	return res;
	}
//=====================================================================

function getUIQueriesList( uiContainer, columns ){
	// v. 1.1
	/*
	columns = [
		{
			key: "",
			title: "",
			width: 100, // number,
			type: "", // edittext | checkbox | radiobutton | dropdownlist,
			default_value: "false",
			values: ["","",""], // array of strings // Only for radiobutton | dropdownlist
		}
	uiContainer.XML - текущий Xml: <queries><query/></queries>
	uiContainer.loadXml( xml ) - функция загрузки нового xml
	
	// общая ширина блока будет равна сумме всех width
	*/
	var lang = ( $.locale == 'ru_RU' ) ? 'ru' : 'en';
	var messages = {
		en: {
			up: 'Move up selected item',
			down: 'Move down selected item',
			deleteRow: 'Delete selected item',
			},
		ru: {
			up: 'Двигать строку верх по списку',
			down: 'Двигать строку вниз по списку',
			deleteRow: 'Удалить строку',
			}
		};
	
	var titles = [];
	var widths = [];
	var full_width = 0;
	var default_xml_node = <query/>;
	for( var i = 0; i < columns.length; i++ ){
		titles.push( columns[i].title || columns[i].key );
		widths.push( columns[i].width );
		full_width += columns[i].width;
		default_xml_node.@[columns[i].key] = columns[i].default_value;
		}
	var listColumnsSource = {
		numberOfColumns: columns.length, 
		showHeaders: true, 
		columnTitles: titles,
		columnWidths: widths
		};
	// ширину будет задавать группа listFields, а listButs и listBox просто растягиваются по ширине
	uiContainer.orientation = 'column';
	uiContainer.alignChildren = ['left', 'top'];
	uiContainer.spacing = 5;
	uiContainer.XML = <queries/>; // объект настроек по умолчанию
	with(uiContainer){
		uiContainer.listButs = add( "group", undefined, undefined );
		uiContainer.listButs.alignment = ['fill', 'top'];
		uiContainer.listButs.alignChildren = ['right', 'center'];
//		uiContainer.listButs.preferredSize.width = full_width;
		uiContainer.listButs.spacing = 5;
		with(uiContainer.listButs){
			uiContainer.listButs.up = add( "button", undefined, '^', {name: -1, } );
			uiContainer.listButs.up.helpTip = messages[lang].up;
			uiContainer.listButs.down = add( "button", undefined, 'V', {name: 1, } );
			uiContainer.listButs.down.helpTip = messages[lang].down;
			uiContainer.listButs.deleteRow = add( "button", undefined, 'X' );
			uiContainer.listButs.deleteRow.preferredSize.width = 22;
			uiContainer.listButs.deleteRow.helpTip = messages[lang].deleteRow;
			}
		uiContainer.listBox = add( "listbox", undefined, undefined, listColumnsSource );
		uiContainer.listBox.preferredSize.height = 200;
		uiContainer.listBox.alignment = ['fill', 'top'];
	//	uiContainer.listBox.preferredSize.width = full_width;
		uiContainer.listFields = add( "group", undefined, undefined );
		uiContainer.listFields.alignChildren = ['left', 'top'];
		uiContainer.listFields.spacing = 5;
		with(uiContainer.listFields){
			for( var i = 0; i < columns.length; i++ ){
				switch( columns[i].type ){
					case 'edittext':
						uiContainer.listFields[i] = add( columns[i].type, undefined, undefined );
						uiContainer.listFields[i].onChange = editField;
						break;
					case 'checkbox':
						uiContainer.listFields[i] = add( columns[i].type, undefined, columns[i].title );
						uiContainer.listFields[i].onClick = editField;
						break;
					case 'dropdownlist':
						uiContainer.listFields[i] = add( 'dropdownlist', undefined, columns[i].values );
						uiContainer.listFields[i].onChange = editField;
						break;
					case 'radiobutton':
						uiContainer.listFields[i] = add( 'group', undefined, undefined );
						with( uiContainer.listFields[i] ){
							alignChildren = ['left', 'top'];
							orientation = 'column';
							spacing = 5;
							for( var z = 0; z < columns[i].values.length; z++ )
								add( 'radiobutton', undefined, columns[i].values[z] );
							}
						uiContainer.listFields[i].addEventListener( 'click', editField );
						break;
					}
				uiContainer.listFields[i].Key = columns[i].key;
				uiContainer.listFields[i].Index = i;
				uiContainer.listFields[i].preferredSize.width = columns[i].width - (i == columns.length-1 ? 0 : 5); // уменьшаем на размер отступа, последний не уменьшаем
				}
			}
		}
	
	// initialize - инициируем список для расстановки ширины столбцов
	uiContainer.listBox.removeAll();
	uiContainer.listBox.add( 'item', '...' ).addListRow = true;
	
	function getTextForCell( text ){
		text = text.toString();
		if( text == 'false' )
			return '';
		if( text == 'true' )
			return '+';
		return text;
		}
	// Работа с данными поля
	function editField( e ){
		try{
		if( !uiContainer.listBox.selection )
			return;
		
		var uiObject = e ? e.target : this;
		var currentUIObject = e ? e.currentTarget : this;
		var row = uiContainer.listBox.selection;
		
		var value = '';
		if( uiObject.type == 'edittext' )
			value = uiObject.text;
		else if( uiObject.type == 'checkbox' )
			value = uiObject.value;
		else if( uiObject.type == 'radiobutton' )
			value = uiObject.text;
		else if( uiObject.type == 'dropdownlist' )
			value = uiObject.selection ? uiObject.selection.text : '';
//		alert( value );
		if( !currentUIObject.Index )
			row.text = getTextForCell( value );
		else
			row.subItems[currentUIObject.Index-1].text = getTextForCell( value );
		row.xmlNode.@[currentUIObject.Key] = value;
		}catch(err){ alert( err + ', line ' + err.line, 'editField()' ) }
		}
	// Перемещение
	uiContainer.listButs.up.onClick = uiContainer.listButs.down.onClick = function(){
		try{
		var listBox = uiContainer.listBox;
		if(listBox.selection == null || listBox.items.length < 2 )
			return;
		if(this.properties.name == -1 && listBox.selection.index == 0)
			return;
		if(this.properties.name == 1 && listBox.selection.index == listBox.items.length-2)
			return;
		var item = listBox.selection;
		var nextItem = listBox.items[listBox.selection.index + this.properties.name];
		var attribute, this_list_item;
		for( var i = 0; i < item.xmlNode.attributes().length(); i++ ){
			// запоминаем
			attribute = item.xmlNode.attributes()[i];
			// перебрасываем
			item.xmlNode.attributes()[i] = nextItem.xmlNode.attributes()[i];
			this_list_item = i == 0 ? item : item.subItems[i-1];
			this_list_item.text = getTextForCell( item.xmlNode.attributes()[i].toString() );
			
			nextItem.xmlNode.attributes()[i] = attribute;
			this_list_item = i == 0 ? nextItem : nextItem.subItems[i-1];
			this_list_item.text = getTextForCell( nextItem.xmlNode.attributes()[i].toString() );
			}
		listBox.selection = nextItem;
		}catch(err){ alert( err + ', line ' + err.line, 'editField()' ) }
		}
	// Удаление
	uiContainer.listButs.deleteRow.onClick = function(){
		try{
		if( !uiContainer.listBox.selection )
			return;
		if( !confirm('Delete row?') )
			return;
		var item = uiContainer.listBox.selection;
		// удаляем узел. По ссылке item.xmlNode удалить не получится, поэтому идем окольным путем
		delete item.xmlNode.parent().children()[item.xmlNode.childIndex()];
		var next_item_index = item.index ? item.index-1 : (uiContainer.listBox.items.length > 2 ? item.index : null );
		uiContainer.listBox.remove( item );
		if( next_item_index !== null )
			uiContainer.listBox.selection = next_item_index;
		}catch(err){ alert( err + ', line ' + err.line, 'editField()' ) }
		}
	// Выбор
	uiContainer.listBox.onChange = function(){
		try{
		if( !this.selection )
			return;
		if( this.selection.addListRow ){
			uiContainer.addListRow();
			return;
			}
		fillFields( this.selection.xmlNode );
		}catch(err){ alert( err + ', line ' + err.line, 'editField()' ) }
		}
	// Добавление
	uiContainer.addListRow = function( xmlNode, notFillFields ){
		try{
		if( !xmlNode ){
			xmlNode = default_xml_node.copy();
			this.XML.appendChild( xmlNode );
			}
		var item = this.listBox.items[this.listBox.items.length-1];
		item.text = ''; // убираем плюс
		item.xmlNode = xmlNode;
		
		item.addListRow = false;
		var addListRow = this.listBox.add( 'item', '...' );
		addListRow.addListRow = true;
		
		// Заполняем значения строки
		var this_list_item;
		for( var i = 0; i < item.xmlNode.attributes().length(); i++ ){
			this_list_item = i == 0 ? item : item.subItems[i-1];
			this_list_item.text = getTextForCell( item.xmlNode.attributes()[i].toString() );
			}
		// Заполняем поля
		if( !notFillFields )
			fillFields( item.xmlNode );
		
		// Выделяем
		this.listBox.selection = item;
		
		}catch(err){ alert( err + ', line ' + err.line, 'editField()' ) }
		}
	// Заполнение полей
	function fillFields( xmlNode ){ // Если xmlNode не указан - поля просто очищаются
		var fields = uiContainer.listFields.children;
		for( var i = 0; i < fields.length; i++ ){
			var value = xmlNode ? xmlNode.@[fields[i].Key].toString() : '';
			switch( fields[i].type ){
				case 'edittext':
					fields[i].text = value;
					break;
				case 'checkbox':
					fields[i].value = value == 'true';
					break;
				case 'dropdownlist':
					var item = fields[i].find( value );
					if( !item )
						item = fields[i].add( 'item', value );
					fields[i].selection = item.index;
					break;
				case 'group': // radiobutton
					for( var z = 0; z < fields[i].children.length; z++ ){
						if( fields[i].children[z].text == value ){
							fields[i].children[z].value = true;
							break;
							}
						fields[i].children[z].value = false;
						}
					break;
				}
			}
		}
	// Загрузка набора
	uiContainer.loadXml = function( xml ){
		// Очищаем
		while( uiContainer.listBox.items.length > 1 )
			uiContainer.listBox.remove( uiContainer.listBox.items[0] );
		// Очищаем поля
		fillFields();
		
		uiContainer.XML = xml;
		var rows = xml.elements();
		var last_index = rows.length() - 1;
		for( var i = 0; i <= last_index; i++ )
			uiContainer.addListRow( rows[i], (i != last_index) ); // показываем только последний
		}
	}